(* -------------------------------------------------------------------- *)
(*	Test1.ML							*)
(*	Tests of ZF-based ML verifier					*)
(* -------------------------------------------------------------------- *)

(* -------------------------------------------------------------------- *)
(*			Examples					*)
(* -------------------------------------------------------------------- *)

exp_elab "scon n";
by elab_tac;

exp_elab "var times"; 
by elab_tac;

exp_elab "{{p1 = var times, p2 = var minus}}";  
by elab_tac;

dec_elab "val var x1 = scon m";
by elab_tac;

exp_elab "let val var x1 = scon m in var x1 end";
by elab_tac;

exp_elab "con true";
by elab_tac;

dec_elab "val var x1 = scon m; val var x2 = scon n";
by elab_tac;

dec_elab "val var x1 = scon m; val var x2 = scon n; val var x3 = scon k";
by elab_tac;

dec_elab "val var x1 = scon m and  var x2 = scon n";
by elab_tac;

dec_elab "nothing";
by elab_tac;

exp_elab "let val var x1 = scon m; val var x2 = scon n in var x2 end";
by elab_tac;

dec_elab "local val var x1 = scon m in val var x2 = var x1 end";
by elab_tac;



