(* -------------------------------------------------------------*)
(*								*)
(*		elab_exp.thy:					*)
(*								*)
(* ------------------------------------------------------------ *)

elab_exp = elab_exprow +

rules
 					(* Rule 9 is not needed  *)
Apply     "(EX t'. C |- exp1 ~> <FunType, <t', t>> & \
\          C |- exp2 ~> t') <->  C |- exp1`exp2 ~> t" (* Rule 10 *)

Typed     "(C |- exp ~> t & C |- ty ~> t [Ty]) <-> C |- exp : ty ~> t"
						      (* Rule 11 *)

Handle	  "(C |- exp ~> t & C |- match ~> <FunType, <exn, t>> [Match]) <-> \
\           C |- exp handle match ~> t"	              (* Rule 12 *)
   
Raise	  "C |- exp ~> exn <->  C |- raise exp ~> t"   (* Rule 13 *)

Fn	  "C |- match ~> t [Match] <->  C |- fn match ~> t"	(* Rule 14 *)

end
