(* -------------------------------------------------------------*)
(*								*)
(*			elab_ty.thy				*)
(*								*)
(* ------------------------------------------------------------ *)

elab_ty = elab_pat +

rules

TyVar_Ty'        "<TyVar, a> = t <-> C |- %a ~> t [Ty]" (* Rule 47 *)

Empty_Record_Ty "<RecType, 0> = t <-> C |- {{}} ~> t [Ty]" (* Rule 48a *)

Record_Ty   "(EX rectype. C |- tyrow ~> rectype [TyRow] &  \
\          <RecType, rectype> = t) <-> C |- {{tyrow}} ~> t [Ty]" (* Rule 48b *)

TyCon	  "(EX T U SE EE TE VE theta CE tyvarseq.  <T, U, SE, TE, VE, EE> = C &\
\           TE ` <TyCon, tycon> = <theta, CE> &    \
\          theta = <Lam, tyvarseq, t> & C |- tyseq ~> typeseq [TySeq] & \
\          subst_seq (t, typeseq, tyvarseq, t'))  <-> \
\          C |- tyseq tycon ~> t' [Ty]" 	(* Rule 49 *)

Fn_Ty     "(C |- ty ~> t [Ty] & C |- ty' ~> t' [Ty] & \
\        <FunType, t, t'> = t'') <-> C |- ty -ty-> ty' ~> t''[Ty]" (* Rule 50 *)

Bracket_Ty   "C |- ty ~> t [Ty] <-> C |- (-ty-) ~> t [Ty]" (* Rule 51 *)

end
