(* -------------------------------------------------------------*)
(*								*)
(*		elab_valbind.thy:				*)
(*								*)
(* ------------------------------------------------------------ *)

elab_valbind = elab_dec +

rules

ValBind1    "(EX t. C ||- pat ~> (VE, t) [Pat] & C |- exp ~> t) <-> \
\            C ||- pat = exp ~> VE [ValBind]"  (* Rule 26a *)


ValBind2    "(EX VE VE' t. C ||- pat ~> (VE, t) [Pat] & \
\             C |- exp ~> t & C ||- valbind ~> VE' [ValBind] & \
\             VE @@ VE' = VE'') <->  \
\            C ||- pat = exp and valbind ~> VE'' [ValBind] "  (* Rule 26b *)

Rec        "(EX C'.  C ## <0, 0, 0, 0, VE, 0> = C' & \
\            C' ||- valbind ~> VE [ValBind]) <->  \
\           C ||-  rec valbind ~> VE [ValBind]" (* Rule 27 *)

end
