(* -------------------------------------------------------------------- *)
(*	Test1.ML							*)
(*	Tests of ZF-based ML verifier					*)
(* -------------------------------------------------------------------- *)

(* -------------------------------------------------------------------- *)
(*			Examples					*)
(* -------------------------------------------------------------------- *)


exp_eval "scon n";
by eval_tac;

exp_eval "var times"; 
by eval_tac;

exp_eval "{{p1 = var times, p2 = var minus}}";  
by eval_tac;

dec_eval "val var x1 = scon m";
by eval_tac;

exp_eval "let val var x1 = scon m in var x1 end";
by eval_tac;

exp_eval "con true";
by eval_tac;

dec_eval "val var x1 = scon m; val var x2 = scon n";
by eval_tac;

dec_eval "val var x1 = scon m; val var x2 = scon n; val var x3 = scon k";
by eval_tac;

dec_eval "val var x1 = scon m and  var x2 = scon n";
by eval_tac;

dec_eval "nothing";
by eval_tac;

exp_eval "let val var x1 = scon m; val var x2 = scon n in var x2 end";
by eval_tac;

dec_eval "local val var x1 = scon m in val var x2 = var x1 end";
by eval_tac;




