(* -------------------------------------------------------------*)
(*								*)
(*		eval_valbind.thy				*)
(*								*)
(* ------------------------------------------------------------ *)

eval_valbind = eval_dec +

rules
				(* Rule 135a *)
ValBind1	"(EX v. E |- exp ~> <Val, v>  & \
\                 E, v ||- pat ~> <VarEnv, VE>  [Pat] ) <->  \
\                 E ||- pat = exp ~> VE  [ValBind]"
					(* Rule 135b *)
ValBind2	"(EX v VE VE'. E |- exp ~><Val, v>  & \
\                 E, v ||- pat ~> <VarEnv, VE>   [Pat] & \
\                 E ||- valbind ~> VE'  [ValBind] & \
\                 VE @@ VE' = VE'') <->  \
\                 E ||- pat = exp and valbind ~> VE''  [ValBind]"

ValBind3	"(EX v. E |- exp ~> <Val, v>  & \
\                 E, v ||- pat ~> FAIL  [Pat] & \
\                 <Raised, ExVal, ExName, BIND> = pack) <->  \
\                 E ||- pat = exp ~> pack  [ValBind]"  (* Rule 136a  *)
						 
ValBind4	"(EX v VE VE'. E |- exp ~> <Val, v>  & \
\                 E, v ||- pat ~> FAIL   [Pat] & \
\                 <Raised, ExVal, ExName, BIND> = pack) <->  \
\                 E ||- pat = exp and valbind ~> pack  [ValBind]"(*Rule 136b  *)
					
Rec	"(E ||- valbind ~> VE  [ValBind] & Rec (VE, VE) = VE') \
\       <-> E ||- rec valbind ~>  VE' [ValBind]"(* Rule 137 *)
				           (* Rules 138-139 omitted *)


end
