(* ------------------------------------------------------------ *)
(*								*)
(*	 ROOT.ML:  root file for FUNC 				*)
(*	 Common Material for both Evaluation and Elaboration	*)
(*	 to be loaded within ZF+				*)
(*								*)
(* ------------------------------------------------------------ *)

val banner = "Elle: Kernel\n\n";

print banner;

print_depth 1; 

use "Tools.ML";
use "More_ZF.ML";
use "More_Arith.ML";

use_thy "identifiers";  (* do this first, because the parse/print  *)
                        (* translations in sml_syntax.thy make use *)
                        (* of functions defined here               *)
 
(*
use_thy "SML_Syntax";    
*)

use_thy "Kernel";    
