(* -------------------------------------------------------------------- *)
(*			 Identifiers.ML	  				*)
(* -------------------------------------------------------------------- *)

open identifiers;


val Ide_elim_rules = (map make_elim 
              [invar_inject, intyvar_inject, intycon_inject, instrid_inject, 
               inlabel_inject, incon_inject, inexcon_inject]);


val injection_rules = 
 let val X = [invar_type, intyvar_type, intycon_type, instrid_type, 
inlabel_type, incon_type, inexcon_type]
 in
     X @ map make_iff_T X
 end;


